# -*- coding: utf-8 -*-

from django.db import models
from django.utils.encoding import python_2_unicode_compatible

from cms.models import CMSPlugin


@python_2_unicode_compatible
class Category(models.Model):
    name = models.CharField(
        max_length=500,
    )
    order = models.IntegerField(
        default=0,
    )

    def __repr__(self):
        return '{}: {}'.format(self.id, self.name)

    def __str__(self):
        return self.name

    class Meta:
        ordering = [
            'order',
        ]


@python_2_unicode_compatible
class Reference(models.Model):
    name = models.CharField(
        max_length=50,
        blank=True,
    )
    image = models.ImageField(
    )
    alt = models.CharField(
        max_length=50,
        blank=True,
    )
    link = models.URLField(
        blank=True,
    )
    categories = models.ManyToManyField(
        Category,
        related_name='references'
    )
    order = models.IntegerField(
        default=0,
    )

    def __repr__(self):
        return '{}: {}'.format(self.id, self.name)

    def __str__(self):
        return self.name

    class Meta:
        ordering = [
            'order',
        ]


class ReferencePlugin(CMSPlugin):
    categories = models.ManyToManyField(
        Category,
        related_name='plugins',
    )
